<?php

defined('_JEXEC') or die('Restricted access');


if (!class_exists('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentEnlineapagos extends vmPSPlugin {

	function __construct(& $subject, $config) {

		parent::__construct($subject, $config);

		$this->_loggable = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; //virtuemart_enlineapagos_id';
		$this->_tableId = 'id'; //'virtuemart_enlineapagos_id';
		$varsToPush = array('enlineapagos_merchant_email' => array('', 'char'),
			'enlineapagos_verified_only' => array('', 'int'),
			'payment_currency' => array('', 'int'),
			'email_currency' => array('', 'int'),
			'log_ipn' => array('', 'int'),
			'sandbox' => array(0, 'int'),
			'sandbox_merchant_email' => array('', 'char'),
			'payment_logos' => array('', 'char'),
			'debug' => array(0, 'int'),
			'status_pending' => array('', 'char'),
			'status_success' => array('', 'char'),
			'status_canceled' => array('', 'char'),
			'status_refunded' => array('', 'char'),
			'countries' => array('', 'char'),
			'min_amount' => array('', 'int'),
			'max_amount' => array('', 'int'),
			'secure_post' => array('', 'int'),
			'ipn_test' => array('', 'int'),
			'no_shipping' => array('', 'int'),
			'address_override' => array('', 'int'),
			'cost_per_transaction' => array('', 'int'),
			'cost_percent_total' => array('', 'int'),
			'tax_id' => array(0, 'int')
		);

		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

	}

	/**
	 * @return string
	 */
	public function getVmPluginCreateTableSQL() {

		return $this->createTableSQL('Enlineapagos Tabla');
	}

	/**
	 * @return array
	 */
	function getTableSQLFields() {

		$SQLfields = array(
			'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id' => 'int(1) UNSIGNED',
			'order_number' => 'char(64)',
			'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
			'payment_name' => 'varchar(5000)',
			'payment_order_total' => 'decimal(15,5) NOT NULL',
			'payment_currency' => 'smallint(1)',
			'email_currency' => 'smallint(1)',
			'cost_per_transaction' => 'decimal(10,2)',
			'cost_percent_total' => 'decimal(10,2)',
			'tax_id' => 'smallint(1)',
			'enlineapagos_custom' => 'varchar(255)',
			'enlineapagos_response_mc_gross' => 'decimal(10,2)',
			'enlineapagos_response_mc_currency' => 'char(10)',
			'enlineapagos_response_invoice' => 'char(32)',
			'enlineapagos_response_protection_eligibility' => 'char(128)',
			'enlineapagos_response_payer_id' => 'char(13)',
			'enlineapagos_response_tax' => 'decimal(10,2)',
			'enlineapagos_response_payment_date' => 'char(28)',
			'enlineapagos_response_payment_status' => 'char(50)',
			'enlineapagos_response_pending_reason' => 'char(50)',
			'enlineapagos_response_mc_fee' => 'decimal(10,2)',
			'enlineapagos_response_payer_email' => 'char(128)',
			'enlineapagos_response_last_name' => 'char(64)',
			'enlineapagos_response_first_name' => 'char(64)',
			'enlineapagos_response_business' => 'char(128)',
			'enlineapagos_response_receiver_email' => 'char(128)',
			'enlineapagos_response_transaction_subject' => 'char(128)',
			'enlineapagos_response_residence_country' => 'char(2)',
			'enlineapagos_response_txn_id' => 'char(32)',
			'enlineapagos_response_txn_type' => 'char(32)',
			'enlineapagos_response_parent_txn_id' => 'char(32)',
			'enlineapagos_response_case_creation_date' => 'char(32)',
			'enlineapagos_response_case_id' => 'char(32)',
			'enlineapagos_response_case_type' => 'char(32)',
			'enlineapagos_response_reason_code' => 'char(32)',
			'enlineapagosresponse_raw' => 'varchar(512)',
		);
		return $SQLfields;
	}

	/**
	 * @param $cart
	 * @param $order
	 * @return bool|null
	 */
	function plgVmConfirmedOrder($cart, $order) {

		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return NULL; 
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->_debug = $method->debug;
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		if (!class_exists('VirtueMartModelCurrency')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		}

		$address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

		if (!class_exists('TableVendors')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'tables' . DS . 'vendors.php');
		}
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$email_currency = $this->getEmailCurrency($method);
		$currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');

		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, FALSE), 2);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
		if ($totalInPaymentCurrency <= 0) {
			vmInfo(JText::_('VMPAYMENT_ENLINEAPAGOS_PAYMENT_AMOUNT_INCORRECT'));
			return FALSE;
		}
		$merchant_email = $this->_getMerchantEmail($method);
		if (empty($merchant_email)) {
			vmInfo(JText::_('MS26'));
			return FALSE;
		}
		
		$sandbox_merchant_email = $this->_getKey($method);
		if (empty($merchant_email)) {
			vmInfo(JText::_('MS27'));
			return FALSE;
		}
		
		$quantity = 0;
		foreach ($cart->products as $key => $product) {
			$quantity = $quantity + $product->quantity;
		}

		
include(dirname(__FILE__).'/configuracion.php');
$total=	$totalInPaymentCurrency;	 
$ValordelIvaManual="1.$Valor_Calculo_Iva";
$Currency=$Currency_Code;
$ValorDelIva1=$total/$ValordelIvaManual;
$ValorDelIva2=$total-$ValorDelIva1;
$ValorDelIva=number_format($ValorDelIva2, 2, '.', '');
$ValorBaseIva1=$total-$ValorDelIva;
$ValorBaseIva=number_format($ValorBaseIva1, 2, '.', '');


		$post_variables = Array(
			'usuario' => $merchant_email, 
			'llavemd5' => $sandbox_merchant_email, 
			'referencia' => $order['details']['BT']->order_number,				
			'descripcion' => JText::_('Pago de Orden de Compra ') . '# ' . $order['details']['BT']->order_number,
			"valor" => $totalInPaymentCurrency,
			"iva" => $ValorDelIva,
			"baseiva" => $ValorBaseIva,
			"moneda" => $currency_code_3,
		    "nombres" => $address->first_name,
			"apellidos" => $address->last_name,
			"direccion" => $address->address_1,				
			"email" => $order['details']['BT']->email,
			"telefono" => $address->phone_1
			);

		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
		$dbValues['enlineapagos_custom'] = $return_context;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['email_currency'] = $email_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);

		$url = $this->_getEnlineapagosUrlHttps($method);

		// add spin image
		$html = '<html><head><title>Enviando...</title></head><body><div style="margin: auto; text-align: center;">';
		$html .= '<form action="' . "https://" . $url . '" method="post" name="vm_enlineapagos_form"  accept-charset="UTF-8">';
		$html .= '<input type="submit"  value="' . JText::_('MS25') . '" />';
		$html .= '<input type="hidden" name="charset" value="utf-8">';
		foreach ($post_variables as $name => $value) {
			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		$html .= '</form>';
		$html .= ' <script type="text/javascript">';
		
		
		
	$html .= ' document.vm_enlineapagos_form.submit();';
	
		$html .= ' </script></body></html>';

		// 	2 = don't delete the cart, don't send email and don't redirect
		$cart->_confirmDone = FALSE;
		$cart->_dataValidated = FALSE;
		$cart->setCartIntoSession();
		
		
	include(dirname(__FILE__).'/licencia.lic');
$dominiolicenciado1=$LicenseKEY;
$dominiolicenciado="$dominiolicenciado1";

$urlSistema=$_SERVER["SERVER_NAME"];

$urlSistema1=str_replace(":443", "", $urlSistema);
$urlSistema2=str_replace("https://", "", $urlSistema1);
$urlSistema3=str_replace("http://", "", $urlSistema2);
$urlSistema4=str_replace("www.", "", $urlSistema3);
$urlSistema5="$urlSistema4.4bc48e9of22XER8AsENLINEAPAGOS";
$urlSistema6=md5($urlSistema5); 


if($dominiolicenciado=="$urlSistema6"){
JRequest::setVar('html', $html);
	}else{
	
echo "<b>La Licencia Actual para utilizar este Modulo no es valida para este dominio o servidor, por favor contacte a Soporte o a su Vendedor del Producto.<br></b>";
echo"Este dominio $urlSistema4 no cuenta con Licencia para utilizar este Modulo.<br>"; 
echo "<br><a href=http://www.enlineapagos.com target=_blank>Adquirir una Licencia</a>";
exit();

	}		
		
		

		/*

			  $qstring = '?';
			  foreach ($post_variables AS $k => $v) {
			  $qstring .= ( empty($qstring) ? '' : '&')
			  . urlencode($k) . '=' . urlencode($v);
			  }
			  // we can display the logo, or do the redirect
			  $mainframe = JFactory::getApplication();
			  $mainframe->redirect("https://" . $url . $qstring);


			  return false; // don't delete the cart, don't send email
			 */
	}

	/**
	 * @param $virtuemart_paymentmethod_id
	 * @param $paymentCurrencyId
	 * @return bool|null
	 */
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}

	/**
	 * @param $virtuemart_paymentmethod_id
	 * @param $paymentCurrencyId
	 * @return bool|null
	 */
	function plgVmgetEmailCurrency($virtuemart_paymentmethod_id, $virtuemart_order_id, &$emailCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		if (empty($payments[0]->email_currency)) {
			$vendorId = 1; //VirtueMartModelVendor::getLoggedVendor();
			$db = JFactory::getDBO();
			$q = 'SELECT   `vendor_currency` FROM `#__virtuemart_vendors` WHERE `virtuemart_vendor_id`=' . $vendorId;
			$db->setQuery($q);
			$emailCurrencyId = $db->loadResult();
		} else {
			$emailCurrencyId = $payments[0]->email_currency;
		}

	}

	/**
	 * @param $html
	 * @return bool|null|string
	 */
	function plgVmOnPaymentResponseReceived(&$html) {

		if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		//vmdebug('PAYPAL plgVmOnPaymentResponseReceived', $enlineapagos_data);
		// the payment itself should send the parameter needed.
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		$payment_name = $this->renderPluginName($method);
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);
		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return TRUE;
	}

	/**
	 * @return bool|null
	 */
	function plgVmOnUserPaymentCancel() {

		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$order_number = JRequest::getString('on', '');
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', '');
		if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {
			return NULL;
		}
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			return NULL;
		}

		VmInfo(Jtext::_('VMPAYMENT_ENLINEAPAGOS_PAYMENT_CANCELLED'));
		$session = JFactory::getSession();
		$return_context = $session->getId();
		if (strcmp($paymentTable->enlineapagos_custom, $return_context) === 0) {
			$this->handlePaymentUserCancel($virtuemart_order_id);
		}
		return TRUE;
	}

	/*
		 *   plgVmOnPaymentNotification() - This event is fired by Offline Payment. It can be used to validate the payment data as entered by the user.
		 * Return:
		 * Parameters:
		 *  None
		 *  @author Valerie Isaksen
		 */

	/**
	 * @return bool|null
	 */
	function plgVmOnPaymentNotification() {

		//$this->_debug = true;
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		$enlineapagos_data = JRequest::get('post');
		if (!isset($enlineapagos_data['invoice'])) {
			return FALSE;
		}

		$order_number = $enlineapagos_data['invoice'];
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($enlineapagos_data['invoice']))) {
			return FALSE;
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return FALSE;
		}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		$this->_debug = $method->debug;

		$this->logInfo('enlineapagos_data ' . implode('   ', $enlineapagos_data), 'message');
		// _processIPN checks that  $res== "VERIFIED"
		if (!$this->_processIPN($enlineapagos_data, $method)) {
			$this->logInfo('enlineapagos_data _processIPN FALSE', 'message');
			return FALSE;
		}

		//$this->_storeEnlineapagosInternalData ($method, $enlineapagos_data, $virtuemart_order_id, $payment->virtuemart_paymentmethod_id);
		$modelOrder = VmModel::getModel('orders');
		$order = array();

		/*
		 * https://cms.enlineapagos.com/us/cgi-bin/?cmd=_render-content&content_ID=developer/e_howto_html_IPNandPDTVariables
		 * The status of the payment:
		 * Canceled_Reversal: A reversal has been canceled. For example, you won a dispute with the customer, and the funds for the transaction that was reversed have been returned to you.
		 * Completed: The payment has been completed, and the funds have been added successfully to your account balance.
		 * Created: A German ELV payment is made using Express Checkout.
		 * Denied: You denied the payment. This happens only if the payment was previously pending because of possible reasons described for the pending_reason variable or the Fraud_Management_Filters_x variable.
		 * Expired: This authorization has expired and cannot be captured.
		 * Failed: The payment has failed. This happens only if the payment was made from your customer’s bank account.
		 * Pending: The payment is pending. See pending_reason for more information.
		 * Refunded: You refunded the payment.
		 * Reversed: A payment was reversed due to a chargeback or other type of reversal. The funds have been removed from your account balance and returned to the buyer. The reason for the reversal is specified in the ReasonCode element.
		 * Processed: A payment has been accepted.
		 * Voided: This authorization has been voided.
		 *
		 */

		$lang = JFactory::getLanguage();
		$order['customer_notified'] = 1;

		// 1. check the payment_status is Completed
		if (strcmp($enlineapagos_data['payment_status'], 'Completed') == 0) {
			// 2. check that txn_id has not been previously processed
			if ($this->_check_txn_id_already_processed($payments, $enlineapagos_data['txn_id'], $method)) {
				return FALSE;
			}
			// 3. check email and amount currency is correct
			if (!$this->_check_email_amount_currency($payments, $this->_getMerchantEmail($method), $enlineapagos_data)) {
				return FALSE;
			}
			// now we can process the payment
			$order['order_status'] = $method->status_success;
			$order['comments'] = JText::sprintf('VMPAYMENT_ENLINEAPAGOS_PAYMENT_STATUS_CONFIRMED', $order_number);
		} elseif (strcmp($enlineapagos_data['payment_status'], 'Pending') == 0) {
			$key = 'VMPAYMENT_ENLINEAPAGOS_PENDING_REASON_FE_' . strtoupper($enlineapagos_data['pending_reason']);
			if (!$lang->hasKey($key)) {
				$key = 'VMPAYMENT_ENLINEAPAGOS_PENDING_REASON_FE_DEFAULT';
			}
			$order['comments'] = JText::sprintf('VMPAYMENT_ENLINEAPAGOS_PAYMENT_STATUS_PENDING', $order_number) . JText::_($key);
			$order['order_status'] = $method->status_pending;
		} elseif (strcmp($enlineapagos_data['payment_status'], 'Refunded') == 0 and isset($method->status_refunded)) {
			if ($this->_is_full_refund($payments, $enlineapagos_data)) {
				$order['comments'] = JText::sprintf('VMPAYMENT_ENLINEAPAGOS_PAYMENT_STATUS_REFUNDED', $order_number);
				$order['order_status'] = $method->status_refunded;
			} else {
				$order['comments'] = JText::sprintf('VMPAYMENT_ENLINEAPAGOS_PAYMENT_STATUS_PARTIAL_REFUNDED', $order_number);
				$order['order_status'] = isset($method->status_partial_refunded) ? $method->status_partial_refunded:'R' ;
			}

		} elseif (isset ($enlineapagos_data['payment_status'])) {
			$order['order_status'] = $method->status_canceled;
		} else {
			/*
			* a notification was received that concerns one of the payment (since $enlineapagos_data['invoice'] is found in our table),
			* but the IPN notification has no $enlineapagos_data['payment_status']
			* We just log the info in the order, and do not change the status, do not notify the customer
			*/
			$order['comments'] = JText::_('VMPAYMENT_ENLINEAPAGOS_IPN_NOTIFICATION_RECEIVED');
			$order['customer_notified'] = 0;
		}
		$this->_storeEnlineapagosInternalData($method, $enlineapagos_data, $virtuemart_order_id, $payments[0]->virtuemart_paymentmethod_id);
		$this->logInfo('plgVmOnPaymentNotification return new_status:' . $order['order_status'], 'message');

		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		//// remove vmcart
		if (isset($enlineapagos_data['custom'])) {
			$this->emptyCart($enlineapagos_data['custom'], $order_number);
		}
		//die();
	}

	function logIpn() {

		$file = JPATH_ROOT . "/logs/enlineapagos-ipn.log";
		$date = JFactory::getDate();

		$fp = fopen($file, 'a');
		fwrite($fp, "\n\n" . $date->toFormat('%Y-%m-%d %H:%M:%S'));
		fwrite($fp, "\n" . var_export($_POST, TRUE));
		fclose($fp);
	}

	/**
	 * @param $method
	 * @param $enlineapagos_data
	 * @param $virtuemart_order_id
	 */
	function _storeEnlineapagosInternalData($method, $enlineapagos_data, $virtuemart_order_id, $virtuemart_paymentmethod_id) {

		// get all know columns of the table
		$db = JFactory::getDBO();
		$query = 'SHOW COLUMNS FROM `' . $this->_tablename . '` ';
		$db->setQuery($query);
		$columns = $db->loadResultArray(0);
		$post_msg = '';
		foreach ($enlineapagos_data as $key => $value) {
			$post_msg .= $key . "=" . $value . "<br />";
			$table_key = 'enlineapagos_response_' . $key;
			if (in_array($table_key, $columns)) {
				$response_fields[$table_key] = $value;
			}
		}

		//$response_fields[$this->_tablepkey] = $this->_getTablepkeyValue($virtuemart_order_id);
		$response_fields['payment_name'] = $this->renderPluginName($method);
		$response_fields['enlineapagosresponse_raw'] = $post_msg;
		$response_fields['order_number'] = $enlineapagos_data['invoice'];
		$response_fields['virtuemart_order_id'] = $virtuemart_order_id;
		$response_fields['virtuemart_paymentmethod_id'] = $virtuemart_paymentmethod_id;
		$response_fields['enlineapagos_custom'] = $enlineapagos_data['custom'];

		//$preload=true   preload the data here too preserve not updated data
		$this->storePSPluginInternalData($response_fields);
	}

	/**
	 * Display stored payment data for an order
	 *
	 * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
	 */
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

		if (!$this->selectedThisByMethodId($payment_method_id)) {
			return NULL; // Another method was selected, do nothing
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}

		$html = '<table class="adminlist" width="50%">' . "\n";
		$html .= $this->getHtmlHeaderBE();
		$code = "enlineapagos_response_";
		$first = TRUE;
		foreach ($payments as $payment) {
			$html .= '<tr class="row1"><td>' . JText::_('VMPAYMENT_ENLINEAPAGOS_DATE') . '</td><td align="left">' . $payment->created_on . '</td></tr>';
			// Now only the first entry has this data when creating the order
			if ($first) {
				$html .= $this->getHtmlRowBE('COM_VIRTUEMART_PAYMENT_NAME', $payment->payment_name);
				// keep that test to have it backwards compatible. Old version was deleting that column  when receiving an IPN notification
				if ($payment->payment_order_total and  $payment->payment_order_total != 0.00) {
					$html .= $this->getHtmlRowBE('PAYPAL_PAYMENT_ORDER_TOTAL', $payment->payment_order_total . " " . shopFunctions::getCurrencyByID($payment->payment_currency, 'currency_code_3'));
				}
				if ($payment->email_currency and  $payment->email_currency != 0) {
					$html .= $this->getHtmlRowBE('PAYPAL_PAYMENT_EMAIL_CURRENCY', shopFunctions::getCurrencyByID($payment->email_currency, 'currency_code_3'));
				}
				$first = FALSE;
			}
			foreach ($payment as $key => $value) {
				// only displays if there is a value or the value is different from 0.00 and the value
				if ($value) {
					if (substr($key, 0, strlen($code)) == $code) {
						$html .= $this->getHtmlRowBE($key, $value);
					}
				}
			}

		}
		$html .= '</table>' . "\n";
		return $html;
	}



	/**
	 * Get ipn data, send verification to EnLineaPagos, run corresponding handler
	 *
	 * @param array $data
	 * @return string Empty string if data is valid and an error message otherwise
	 * @access protected
	 */
	private function _processIPN($enlineapagos_data, $method) {

		// check that the remote IP is from Enlineapagos.
		if (!$this->checkEnlineapagosIps($enlineapagos_data['ipn_test'], $enlineapagos_data['invoice'], $method)) {
			$this->logInfo('_processIPN checkEnlineapagosIps FALSE', 'message');
			return FALSE;
		}
		// Enlineapagos wants to open the socket in SSL
		$port = 443;
		$protocol = 'ssl://';
		$enlineapagos_url = $this->_getEnlineapagosURL($method);
		/*
		 * Before we can trust the contents of the message, we must first verify that the message came from EnLineaPagos.
		 * To verify the message, we must send back the contents in the exact order they
		*  were received and precede it with the command _notify-validate,
		 */
		$post_msg = 'cmd=_notify-validate';
		foreach ($enlineapagos_data as $key => $value) {
			if ($key != 'view' && $key != 'layout') {
				$value = urlencode($value);
				$post_msg .= "&$key=$value";
			}
		}

		$header="POST /cgi-bin/webscr HTTP/1.1\r\n";
		$header .= "User-Agent: PHP/" . phpversion () . "\r\n";
		$header .= "Referer: " . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . @$_SERVER['QUERY_STRING'] . "\r\n";
		$header .= "Server: " . $_SERVER['SERVER_SOFTWARE'] . "\r\n";
		$header .= "Host: "  . $this->_getEnlineapagosUrl ($method) . ":" . $port . "\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen ($post_msg) . "\r\n";
		$header .="Connection: close\r\n\r\n";

		$fps = fsockopen($protocol . $enlineapagos_url, $port, $errno, $errstr, 30);

		$valid_ipn = false;
		if (!$fps) {
			$this->sendEmailToVendorAndAdmins("error with enlineapagos", JText::sprintf('VMPAYMENT_ENLINEAPAGOS_ERROR_POSTING_IPN', $errstr, $errno));
			$this->logInfo('_processIPN fsockopen FALSE', 'message');
		} else {
			fputs($fps, $header . $post_msg);
			$this->logInfo('_processIPN Fputs: ' . $header . $post_msg, 'message');
			$res = '';
			while (!feof($fps)) {
				$res .= fgets($fps, 1024);
			}
			fclose($fps);

			$this->logInfo('_processIPN FROM IPN VALIDATION:' . $res, 'message');
			// Inspect IPN validation result and act accordingly
			$valid_ipn = strstr($res, "VERIFIED");
			if (!$valid_ipn) {
				if (strstr($res, "INVALID")) {
					$emailBody = "Hello,\n\nerror with enlineapagos IPN NOTIFICATION" . " " . $res . "\n";
					// If 'INVALID', send an email. TODO: Log for manual investigation.
					foreach ($enlineapagos_data as $key => $value) {
						$emailBody .= $key . " = " . $value . "\n";
					}
					$this->sendEmailToVendorAndAdmins(JText::_('VMPAYMENT_ENLINEAPAGOS_ERROR_IPN_VALIDATION') . " " . $res, $emailBody);
					$this->logInfo('_processIPN INVALID', 'message');
				} else {
					$emailBody = "Hello,
                An error occured while processing a enlineapagos transaction.";
					$this->sendEmailToVendorAndAdmins(JText::_('VMPAYMENT_ENLINEAPAGOS_ERROR_IPN_VALIDATION') . " " . $res, $emailBody);
					$this->logInfo('_processIPN NO ANSWER FROM PAYPAL', 'message');
				}
			}
		}

		$this->logInfo('_processIPN valid_ipn:' . $valid_ipn, 'message');
		return $valid_ipn;
	}

	function _check_txn_id_already_processed($payments, $txn_id, $method) {

		$virtuemart_order_id = $payments[0]->virtuemart_order_id;
		$orderModel = VmModel::getModel('orders');
		$order = $orderModel->getOrder($virtuemart_order_id);

		if ($order['details']['BT']->order_status == $method->status_success) {
			foreach ($payments as $payment) {
				if ($payment->enlineapagos_response_txn_id == $txn_id) {
					return TRUE;
				}
			}
		}
		return FALSE;
	}

	function _check_email_amount_currency($payments, $email, $enlineapagos_data) {

		/*
		 * TODO Not checking yet because config do not have primary email address
		* Primary email address of the payment recipient (that is, the merchant).
		* If the payment is sent to a non-primary email address on your EnLineaPagos account,
		* the receiver_email is still your primary email.
		*/
		/*
		if ($payments[0]->payment_order_total==$email) {
			return true;
		}
		*/
		$currency_code_3 = shopFunctions::getCurrencyByID($payments[0]->payment_currency, 'currency_code_3');
		if (($payments[0]->payment_order_total == $enlineapagos_data['mc_gross']) and ($currency_code_3 == $enlineapagos_data['mc_currency'])) {
			return TRUE;
		}

		$mailsubject = "EnLineaPagos Transaction";
		$mailbody = "Hello,
		An IPN notification was received with an invalid amount or currency
		----------------------------------
		IPN Notification content:
		";
		foreach ($enlineapagos_data as $key => $value) {
			$mailbody .= $key . " = " . $value . "\n\n";
		}
		$this->sendEmailToVendorAndAdmins($mailsubject, $mailbody);

		return FALSE;
	}
	function  _is_full_refund($payments, $enlineapagos_data) {
		if (($payments[0]->payment_order_total == $enlineapagos_data['mc_gross'])) {
				return TRUE;
			} else {
				return FALSE;
		}
	}
	/**
	 * @param $method
	 * @return mixed
	 */
	function _getMerchantEmail($method) {

		return $method->sandbox ? $method->sandbox_merchant_email : $method->enlineapagos_merchant_email;
	}
		function _getKey($method) {

		return $method->sandbox ? $method->sandbox_merchant_email : $method->sandbox_merchant_email;
	}

	/**
	 * @param $method
	 * @return string
	 */
	function _getEnlineapagosUrl($method) {

		$url = $method->sandbox ? 'plataforma.medianetpay.ec' : 'plataforma.medianetpay.ec';

		return $url;
	}

	/**
	 * @param $method
	 * @return string
	 */
	function _getEnlineapagosUrlHttps($method) {

		$url = $this->_getEnlineapagosUrl($method);
		$url = $url . '/secure/gangway/index.do';

		return $url;
	}

	/**
	 * @param $test_ipn
	 * @return mixed
	 */
	function checkEnlineapagosIps($test_ipn, $order_number, $method) {

		// Get the list of IP addresses for www.enlineapagos.com and notify.enlineapagos.com
		if (1 != 1) {
			$enlineapagos_iplist = gethostbynamel('ipn.sandbox.enlineapagos.com');
			$enlineapagos_iplist = (array)$enlineapagos_iplist;
		} else {
			$enlineapagos_iplist1 = gethostbynamel('plataforma.medianetpay.ec');
			$enlineapagos_iplist2 = gethostbynamel('plataforma.medianetpay.ec');
			$enlineapagos_iplist3 = array();
			if (!is_array($enlineapagos_iplist1) or !is_array($enlineapagos_iplist2)) {
				$mail_subject = "EnLineaPagos IPN Transaction Warning on your site: Could not resolve enlineapagos hostname";
				$mail_body = " One of the EnLineaPagos hostname could not be resolved \n";
				if (!is_array($enlineapagos_iplist1)) {
					$enlineapagos_iplist1 = array();
					$mail_body .= " plataforma.medianetpay.ec \n";
				}
				if (!is_array($enlineapagos_iplist2)) {
					$enlineapagos_iplist2 = array();
					$mail_body .= " plataforma.medianetpay.ec \n";
				}
				$this->sendEmailToVendorAndAdmins($mail_subject, $mail_body);
			}

			$enlineapagos_iplist = array_merge($enlineapagos_iplist1, $enlineapagos_iplist2, $enlineapagos_iplist3);
		}
		$this->logInfo('checkEnlineapagosIps: ' . implode(",", $enlineapagos_iplist) . " server is:" . $_SERVER['REMOTE_ADDR'], 'message');
		$hostname = $this->_getEnlineapagosUrl($method);
		//  test if the remote IP connected here is a valid IP address
		if (!in_array($_SERVER['REMOTE_ADDR'], $enlineapagos_iplist)) {
			$mail_subject = "EnLineaPagos IPN Transaction on your site: Possible fraud";
			$mail_body = "Error code 506. Possible fraud. Error with REMOTE IP ADDRESS = " . $_SERVER['REMOTE_ADDR'] . ".
                        The remote address of the script posting to this notify script does not match a valid EnLineaPagos ip address\n
            These are the valid IP Addresses: " . implode(",", $enlineapagos_iplist) .
				"The Order ID received was: " . $order_number;
			$this->sendEmailToVendorAndAdmins($mail_subject, $mail_body);
			return FALSE;
		}
		/*
				if (!($method->sandbox && $test_ipn == 1)) {
					$res = "FAILED";
					$mailsubject = "EnLineaPagos Sandbox Transaction";
					$mailbody = "Hello,
				A fatal error occurred while processing a enlineapagos transaction.
				----------------------------------
				Hostname: $hostname
				URI:" . $_SERVER["REMOTE_ADDR"] .
						" A Enlineapagos transaction was made using the sandbox without your site in Enlineapagos-Debug-Mode";
					//vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
					$this->sendEmailToVendorAndAdmins ($mailsubject, $mailbody);
					return FALSE;
				}
		*/
		$this->logInfo('checkEnlineapagosIps:  OK', 'message');

		return TRUE;
	}

	/**
	 * @param $enlineapagosTable
	 * @param $payment_name
	 * @return string
	 */
	function _getPaymentResponseHtml($enlineapagosTable, $payment_name) {
		VmConfig::loadJLang('com_virtuemart');

		$html = '<table>' . "\n";
		$html .= $this->getHtmlRow('COM_VIRTUEMART_PAYMENT_NAME', $payment_name);
		if (!empty($enlineapagosTable)) {
			$html .= $this->getHtmlRow('PAYPAL_ORDER_NUMBER', $enlineapagosTable->order_number);
			//$html .= $this->getHtmlRow('PAYPAL_AMOUNT', $enlineapagosTable->payment_order_total. " " . $enlineapagosTable->payment_currency);
		}
		$html .= '</table>' . "\n";

		return $html;
	}

	/**
	 * @param VirtueMartCart $cart
	 * @param                $method
	 * @param                $cart_prices
	 * @return int
	 */
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {

		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}

	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 *
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {

		$this->convert($method);

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}

		return FALSE;
	}

	/**
	 * @param $method
	 */
	function convert($method) {

		$method->min_amount = (float)$method->min_amount;
		$method->max_amount = (float)$method->max_amount;
	}

	/**
	 * We must reimplement this triggers for joomla 1.7
	 */

	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 *
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}

	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart, &$msg) {

		return $this->OnSelectCheck($cart);
	}

	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {

		return $this->displayListFE($cart, $selected, $htmlIn);
	}


	/**
	 * @param VirtueMartCart $cart
	 * @param array $cart_prices
	 * @param                $cart_prices_name
	 * @return bool|null
	 */
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}

	function setCartPrices (VirtueMartCart $cart, &$cart_prices, $method) {


		if (!class_exists ('calculationHelper')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'calculationh.php');
		}

		if (!class_exists ('calculationHelper')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'calculationh.php');
		}

		$calculator = calculationHelper::getInstance ();
		$_psType = ucfirst ($this->_psType);
		$taxrules=array();
		if(isset($method->tax_id) and (int)$method->tax_id === -1){

		} else if (!empty($method->tax_id)) {
			$cart_prices[$this->_psType . '_calc_id'] = $method->tax_id;

			$db = JFactory::getDBO ();
			$q = 'SELECT * FROM #__virtuemart_calcs WHERE `virtuemart_calc_id`="' . $method->tax_id . '" ';
			$db->setQuery ($q);
			$taxrules = $db->loadAssocList ();
		} else {
			//This construction makes trouble, if there are products with different vats in the cart
			//on the other side, it is very unlikely to have different vats in the cart and simultaneous it is not possible to use a fixed tax rule for the shipment
			if(!empty($calculator->_cartData['VatTax']) and count ($calculator->_cartData['VatTax']) == 1){
				$taxrules = $calculator->_cartData['VatTax'];
				foreach($taxrules as &$rule){
					$rule['subTotal'] = $cart_prices[$this->_psType . 'Value'];
				}
			} else {
				$taxrules = $calculator->_cartData['taxRulesBill'];
				foreach($taxrules as &$rule){
					unset($rule['subTotal']);
				}
			}
		}


		$cartTotalAmount=$cart_prices['salesPrice'] + $cart_prices['salesPriceShipment'] - $cart_prices['salesPriceCoupon'] ;
			if (isset($method->cost_percent_total)) {
				if (preg_match ('/%$/', $method->cost_percent_total)) {
					$cost_percent_total = (substr ($method->cost_percent_total, 0, -1)) * 0.01;
				} else {
					$cost_percent_total = $method->cost_percent_total * 0.01;
				}
			} else {
				$cost_percent_total=0;
			}
			if (isset($method->cost_per_transaction)) {
				$cost_per_transaction=$method->cost_per_transaction;
			} else {
				$cost_per_transaction=0;
			}
			if (count ($taxrules) > 0) {
				$cost_percent_total_vat =  $calculator->executeCalculation($taxrules, $cost_percent_total, true);
				$cost_per_transaction_vat =  $calculator->executeCalculation($taxrules, $cost_per_transaction, true);
				$NewTotalAmount= ($cartTotalAmount+$cost_per_transaction_vat) / ( 1 -  $cost_percent_total_vat );
				$feeWithVat=$NewTotalAmount-$cartTotalAmount;

				$calculator->setRevert(true);
				$feeNoVat = $calculator->roundInternal($calculator->executeCalculation($taxrules,$feeWithVat, true), 'salesPrice');
				$calculator->setRevert(false);

				$cart_prices[$this->_psType . 'Tax']=$feeWithVat-$feeNoVat;
				$cart_prices['salesPrice' . $_psType] =$feeWithVat;
				$cart_prices[ $this->_psType .'Value'] = $feeNoVat;

				reset($taxrules);
				$taxrule =  current($taxrules);
				$cart_prices[$this->_psType . '_calc_id'] = $taxrule['virtuemart_calc_id'];
			} else {
				$NewTotalAmount=($cartTotalAmount+ $method->cost_per_transaction) / (1 -$cost_percent_total);
				$fee=$NewTotalAmount-$cartTotalAmount;
				$cart_prices['salesPrice' . $_psType] = $fee;
				$cart_prices[$this->_psType . 'Tax']  = 0;
				$cart_prices[$this->_psType . '_calc_id'] = 0;
				$cart_prices[ $this->_psType .'Value'] = $fee;
			}

		return $cart_prices['salesPrice' . $_psType];
	}

	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 *
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

		return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
	}

	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {

		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}


	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {

		return $this->onShowOrderPrint($order_number, $method_id);
	}


	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {

		return $this->declarePluginParams('payment', $name, $id, $data);
	}

	/**
	 * @param $name
	 * @param $id
	 * @param $table
	 * @return bool
	 */
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {

		return $this->setOnTablePluginParams($name, $id, $table);
	}

}

// No closing tag
